package modele.info1.ships;
import info1.ships.BadCoordException;
import info1.ships.ICoord;

import java.lang.*;


/**
 * une implementation de l'interface ICoord manipulant des coordonnées alphanumériques comme "A1", "B6", "J3", etc.
 */

public class Coord implements ICoord {

    String x;
    String y;
    char alphax;
    String Coord;

    /**
     * NB : LA SIGNATURE DU CONSTRUCTEUR DOIT ETRE RESPECTEE
     *
     * constructeur d'un objet Coord
     * @param xy la coordonnée aphanumérique sous la forme d'une chaine de caractères
     * @throws BadCoordException si la chaine de caractère ne permet pas de définir une coordonnée alphanumérique
     */
    public Coord(String xy) throws BadCoordException {
        if(xy.length()==3){
            if (Character.isLetter(xy.charAt(0))&&Character.isDigit(xy.charAt(1))&&Character.isDigit(xy.charAt(2))){
                if (Integer.parseInt(xy.substring(1,3))>10)
                    throw new BadCoordException();
                if (xy.charAt(0)>=75)
                    throw new BadCoordException();

                this.x=xy.substring(0,0);
                this.y=xy.substring(1,3);
                this.alphax=xy.charAt(0);
                this.Coord=xy;

            }
            else {
                throw new BadCoordException();
            }
        }
        if(xy.length()==2){
            if (Character.isLetter(xy.charAt(0)) && Character.isDigit(xy.charAt(1))){
                if (xy.charAt(0)>=75)
                    throw new BadCoordException();
                if (xy.charAt(1)==48)
                    throw new BadCoordException();

                this.x=xy.substring(0,0);
                this.y=xy.substring(1,2);
                this.alphax=xy.charAt(0);
                this.Coord=xy;
            }
            else {
                throw new BadCoordException();
            }
        }
    }

    @Override
    public char getAlphaX() {
        return this.alphax;
    }

    @Override
    public int getX() {
        int i;
        i = alphax-64;
        return i;
    }

    @Override
    public int getY() {
        return Integer.parseInt(y);
    }

    @Override
    public String toString() {
        return this.Coord;
    }

    @Override
    public boolean equals(Object o) {
        return Coord.equals(o.toString());
    }

    @Override
    public int hashCode() {
        int hash = 1;
        hash += Integer.parseInt(y);
        hash += getX();
        return hash;
    }
}