package vue;

import PremiereFenetre.PremiereFenetre;
import info1.network.Player;
import info1.ships.BadCoordException;
import info1.ships.CoordsBadShipException;
import info1.ships.ICoord;
import info1.ships.ShipCategory;
import modele.info1.ships.Bouttons;
import modele.info1.ships.Coord;
import modele.info1.ships.CreationB;
import modele.info1.ships.NavyFleet;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Arrays;
import java.util.List;
import java.util.function.BiPredicate;


public class FenetreConnexion extends JFrame {
    private JTextField pseudo;
    private JButton envoyepseudo;
    private JComboBox pInitialise;

    private JButton rejoindre;
    private JButton creerPartie;
    private JTextArea zoneMessage;

    private JLabel choixDisposition;
    private JButton france;
    private JButton belgique;
    private JTextArea textePays;

    private int[] pays = new int[5];

    public NavyFleet flotte = new NavyFleet();

    public FenetreConnexion(String titre){
        super(titre);

        JPanel principal = new JPanel(new BorderLayout());
        this.setContentPane(principal);

        JPanel north = new JPanel(new FlowLayout());
        JLabel labelpseudo = new JLabel("Pseudo : ");
        north.add(labelpseudo);
        pseudo = new JTextField();
        pseudo.setPreferredSize(new Dimension(100,30));

        north.add(pseudo);
        //north.add(envoyepseudo);
        principal.add(north,BorderLayout.NORTH);

        JPanel grille = new JPanel();
        grille.setLayout(new GridLayout(11,11));

        for (int i = 0; i < 11; i++) {
            String[] lettres = {" ", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J"};
            final JLabel labellettre = new JLabel(lettres[i], SwingConstants.CENTER);
            labellettre.setBorder(BorderFactory.createLineBorder(Color.BLACK));
            grille.add(labellettre);
        }

        int o = 0;
        int j=0;
        int chiffre = 1;
        char lettre = 'A';
        final String[] co = new String[2];
        Bouttons[] bouttons = new Bouttons[100];

        for (int i = 0; i < (11 * 10); i++) {
            String[] nombres = {"1", "2", "3", "4", "5", "6", "7", "8", "9", "10"};
            if (i % 11 == 0) {
                final JLabel labelchiffres = new JLabel(nombres[j], SwingConstants.CENTER);
                labelchiffres.setBorder(BorderFactory.createLineBorder(Color.BLACK));
                grille.add(labelchiffres);
                j++;
            } else {
                if (i % 11 == 1) {
                    lettre = 'A';
                    if (i != 1)
                        chiffre++;
                }
                final Bouttons boutton = new Bouttons(new JButton(), lettre + String.valueOf(chiffre));
                boutton.getButton().setBackground(Color.WHITE);
                boutton.getButton().setEnabled(false);
                bouttons[o] = boutton;
                o++;

                boutton.getButton().setBorder(BorderFactory.createLineBorder(Color.BLACK));
                boutton.getButton().addActionListener(new ActionListener() {
                    @Override
                    public void actionPerformed(ActionEvent e) {
                        if(co[0]==null){
                            co[0]=boutton.getString();
                            boutton.getButton().setBackground(Color.LIGHT_GRAY);
                        } else {
                            co[1] = boutton.getString();
                            final CreationB c = new CreationB(co[0],co[1],pays);
                            try {if(c.TestCreation()!=null){
                                if(flotte.add(c.TestCreation())==0){
                                    c.TestCreation().gettheCategory();
                                    ShipCategory s = c.TestCreation().gettheCategory();
                                    if(s==ShipCategory.SUBMARINE){
                                        pays[0]--;
                                    } if (s==ShipCategory.DESTROYER) {
                                        pays[1]--;
                                    } if (s==ShipCategory.CRUISER) {
                                        pays[2]--;
                                    } if (s==ShipCategory.BATTLESHIP) {
                                        pays[3]--;
                                    } if (s==ShipCategory.AIRCRAFT_CARRIER) {
                                        pays[4]--;
                                    }
                                    System.out.println(Arrays.toString(pays));
                                    System.out.println(flotte.getShips());
                                    List<ICoord> listec = c.TestCreation().getCoords();
                                    for(int i=0;i<100;i++){
                                        if(listec.contains(new Coord(bouttons[i].getString()))){
                                            bouttons[i].getButton().setBackground(Color.GRAY);
                                            bouttons[i].getButton().setEnabled(false);
                                        }
                                    }
                                } else {
                                    JOptionPane.showMessageDialog(null, "Flotte déja pleine");
                                    for(int i=0;i<100;i++){
                                        if(bouttons[i].getString().equals(co[0])){
                                            bouttons[i].getButton().setBackground(Color.WHITE);
                                        }
                                    }
                                }
                            } else {
                                for(int i=0;i<100;i++){
                                    if(bouttons[i].getString().equals(co[0])){
                                        bouttons[i].getButton().setBackground(Color.WHITE);
                                    }
                                }
                                co[0]=null;
                            }
                            } catch (CoordsBadShipException coordsBadShipException) {coordsBadShipException.printStackTrace();} catch (BadCoordException badCoordException) {badCoordException.printStackTrace();}

                            co[0]=null;
                            co[1]=null;
                        }
                    }
                });
                grille.add(boutton.getButton());
            }
            lettre++;
        }
        principal.add(grille,BorderLayout.CENTER);

        JPanel bas = new JPanel(new BorderLayout());
        envoyepseudo = new JButton("Valider pseudo et flotte");
        envoyepseudo.setPreferredSize(new Dimension(100,30));
        bas.add(envoyepseudo,BorderLayout.CENTER);

        zoneMessage = new JTextArea("ZONE MESSAGE \n pseudo et flotte");
        zoneMessage.setPreferredSize(new Dimension(100,50));
        zoneMessage.setEditable(false);
        bas.add(zoneMessage,BorderLayout.NORTH);

        principal.add(bas, BorderLayout.SOUTH);


        JPanel est = new JPanel(new GridLayout(10,1));

        pInitialise = new JComboBox();
        est.add(pInitialise);

        JPanel boutons = new JPanel(new FlowLayout());
        rejoindre = new JButton("Rejoindre");
        creerPartie = new JButton("Créer partie");
        boutons.add(rejoindre);
        boutons.add(creerPartie);
        est.add(boutons);

        choixDisposition = new JLabel("Quelle dispositions voulez-vous choisir ?");
        est.add(choixDisposition);
        france = new JButton("France");
        belgique = new JButton("Belgique");
        est.add(france);
        est.add(belgique);

        textePays = new JTextArea("La flotte de votre pays",800,20);
        textePays.setEditable(false);
        est.add(textePays);



        principal.add(est,BorderLayout.EAST);


        rejoindre.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                PremiereFenetre.close();
                FenetreJeux fJeux = new FenetreJeux("yolo");
                fJeux.setPreferredSize(new Dimension(700, 700));
                fJeux.pack();
                fJeux.setVisible(true);
            }
        });
        france.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                france.setEnabled(false);
                belgique.setEnabled(true);
                textePays.setText("Bateau de la france:\n1 porte-avions, 1 cuirassé\n2 croiseurs, 2 Torpilleur, 1 Sous-marins");
                pays[0] = 1; pays[1] = 2; pays[2] = 2; pays[3] = 1; pays[4] = 1;
                for(int i=0;i<100;i++){
                    bouttons[i].getButton().setBackground(Color.WHITE);
                    bouttons[i].getButton().setEnabled(true);
                }
                flotte = new NavyFleet();
                System.out.println(Arrays.toString(pays));
            }
        });

        belgique.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                france.setEnabled(true);
                belgique.setEnabled(false);
                textePays.setText("Bateau de la france\n1 cuirassé, 2 croiseurs\n3 Torpilleur, 4 Sous-marins");
                pays[0] = 4; pays[1] = 3; pays[2] = 2; pays[3] = 1; pays[4] = 0;
                for(int i=0;i<100;i++){
                    bouttons[i].getButton().setBackground(Color.WHITE);
                    bouttons[i].getButton().setEnabled(true);
                }
                flotte = new NavyFleet();
                System.out.println(Arrays.toString(pays));
            }
        });




    }

    // Les getters
    public String getPseudo(){ return pseudo.getText(); }

    // public Integer getGameID(){ return gameId; }
    public NavyFleet getFlotte(){ return flotte;}
    public Boolean getCreerpartie() { return true; }

    // Les setters
    // public void setGameID(Integer i){ gameId = i; }

    // public void setCreerpartie(Boolean bool) { creerPartie = bool; }

    // Autres fonctions
    public void visibleCreer(){ creerPartie.setEnabled(true); }

    public void visibleRejoidre(){ rejoindre.setEnabled(true); }

}
